pipeline {
    environment {
        //registry information is required as a parameter when building jenkins.
        registry = "${DOCKER_REGISTRY}"
        registryCredential = "${DOCKER_REGISTRY_CREDENTIAL}"
        tagName = "20.0.0.${env.BUILD_NUMBER}"
        imageName = 'of21-batch-211022'
    } 
    agent any

    stages {
        stage('Build Java Application') {
            steps {
                sh 'cd build-batchApp;./gradlew fatJar'
            }
        }

        stage('Build Docker Image') {
            steps{
                script{
                    batchImage = docker.build(imageName)
                }
            }
        }

        stage('Push Docker Image') {
            steps{
                script{
                    docker.withRegistry( 'http://$registry', registryCredential) {
                        batchImage.push(tagName)
                        batchImage.push("latest")
                    }
                }
            }
        }
    }
}
